#include "BackGround.h"


// All sprited needed
static GsSPRITE *BackSprite;
static GsSPRITE *TimeWord;
static GsSPRITE *TimeBar;
static GsSPRITE *Hurry;
static GsSPRITE *Congratulate;
static GsSPRITE *TimeUp;
static GsSPRITE *Aborted;

static int StartLevel; // Frame number when level is started
static int Frames; // Frames the level may run 
static int PauseStart; // Frame number when pause is started
static short crossed; // Set when Hurry Up displayed
static short count; // Animation phaes for Hurry Up
static short AnimationPhase; // Used for congratiulations, Time Up and 
                             // Level Aborted

static short AnimationType;
// 0: None 1: Congratulation 2: Time Up 3: Aborted




void InitializeBackground()
{
	BackSprite=loadSprite("ImageData/Backgr.tim");
	BackSprite->scalex=12207;
	BackSprite->mx=BackSprite->my=0;
	BackSprite->y=-120;
	TimeWord=loadSprite("ImageData/Time.tim");
	TimeWord->x=-115;
	TimeWord->y=-110;
	Hurry=loadSprite("ImageData/HuUp.tim");
	Hurry->x=-100;
	Hurry->y=-25;
	Congratulate=loadSprite("ImageData/Congr.tim");
	Congratulate->x=-100;
	Congratulate->y=-25;
	TimeUp=loadSprite("ImageData/TimUp.tim");
	TimeUp->x=-100;
	TimeUp->y=-25;
	Aborted=loadSprite("ImageData/Abort.tim");
	Aborted->x=-100;
	Aborted->y=-25;
	TimeBar=loadSprite("ImageData/balken.tim");
	TimeBar->x=-85;
	TimeBar->y=-110;
}

void InitializeTime(short seconds)
{
	StartLevel=VSync(-1);
	Frames=seconds*50;
	crossed=0;
	count=0;
	AnimationPhase=0;
	AnimationType=0;
}


// Shos one of the finalling animations
static void PerformAnimation()
{
	short xposition;
	GsOT *foreGround;
		
	foreGround=getForeGround();
	if (AnimationPhase<10)
		xposition=-100-26*(10-AnimationPhase);
	else if (AnimationPhase>40)
		xposition=-100+26*(AnimationPhase-40);
	else
		xposition=-100;
	switch (AnimationType)
	{
		case 1: Congratulate->x=xposition;
				GsSortFastSprite(Congratulate,foreGround,1);
				break;
		case 2: TimeUp->x=xposition;
				GsSortFastSprite(TimeUp,foreGround,1);
				break;
		case 3: Aborted->x=xposition;
				GsSortFastSprite(Aborted,foreGround,1);
				break;
	}
	AnimationPhase+=1;
}

void DrawBackground()
{
	GsOT *orderTable; // Back ground
	GsOT *foreGround;
	short shift; // Horrizontal offset for horrizon
	long turn;  // Horrizontal angle
	short length; // Length of the time bar
	long yshift; // Vertical offset for horrizon
	
	turn=getRotation()%ONE;
	orderTable=getBackGround();
	foreGround=getForeGround();
	length=200-200*(VSync(-1)-StartLevel)/Frames; // Length of the time bar
	if ((length>=0)&&(AnimationType==0))
	{
		TimeBar->w=length;
		if ((length<=50)&&(crossed==0))
		{
			crossed=1;
			SwitchToNervous();
		}
		if ((length<=50)&&(count<50))
		{
			if (count<10)
				Hurry->x=-100-26*(10-count);
			else if (count>40)
				Hurry->x=-100+26*(count-40);
			else
				Hurry->x=-100;
			count++;
			GsSortFastSprite(Hurry,foreGround,1);
		}
	}
	GsSortFastSprite(TimeWord,foreGround,1);
	GsSortFastSprite(TimeBar,foreGround,1);
	if (AnimationType>0)
		PerformAnimation();
	yshift=-120-(120*360*getVertical()/(31*4096));
	BackSprite->y=yshift;
	if (turn<2048)
	{	
		shift=-160-turn*1490/ONE;	
		BackSprite->x=shift;
		GsSortSprite(BackSprite,orderTable,0);
		BackSprite->scalex*=-1;
		BackSprite->x+=1490;
		GsSortSprite(BackSprite,orderTable,1); 
		BackSprite->scalex*=-1;
	}
	else
	{	
		turn-=2048;
		BackSprite->scalex*=-1;
		shift=745-160-turn*1490/ONE;
		BackSprite->x=shift;
		GsSortSprite(BackSprite,orderTable,0);
		BackSprite->scalex*=-1;
		// BackSprite->x+=745;
		GsSortSprite(BackSprite,orderTable,1); 
	} 
	
}

// Check if game is over
int IsOver()
{
	return(VSync(-1)>(StartLevel+Frames+2));
}

void SetAnimation(short animate)
{
	AnimationType=animate;
}

void EnterPause()
{
	PauseStart=VSync(-1);
}

void ExitPause()
{
	StartLevel+=(VSync(-1)-PauseStart);
}