#ifndef __BoxManager__
#define __BoxManager__
#include <libps.h>
#include "GraphicPrim.h"
#include "SettingManager.h"
#include "SoundEffects.h"
/* This modlue does the drawing of the boxes, the collision detection with the boxes
   and the moving of the boxes. */
   
// Initializes all necesarry data structures
void InitializeBoxes(short *LevelDescription,int offset);

// Draws all the boxes
void DrawBoxes();


// Looks if a box is blocking the players path
int noBox(unsigned short xpos,unsigned short ypos);

// Performs a subdivision on the box, if a box is present
void SubdivideBox(unsigned short xpos,unsigned short ypos);

// Performs a rough subdivision
void RoughSubdivideBox(unsigned short xpos, unsigned short ypos);

// Perfroms a reunification of the box, if the box is present.
void UnifyBox(unsigned short xpos,unsigned short ypos);

// Moves the box from the push position towards the target position
void MoveBox(unsigned short pushPosition[2],
			 unsigned short targetPosition[2]);


// Returns true if all boxes are placed correctly			 
int isWinning();
			 
#endif