#ifndef __SoundEffects__
#define __SoundEffects__
/* This file describes the loading of the sound effects and performs the 
playing. The initialization method has to be called in advance to load
all the necessary files form the disc and the PC. */
#include <libps.h>
#include "FileIO.h"



// Loads all the necesarry files
void InitSound();

// Plays the normal background music
void PlayBackground();

// Switches to the more nervous music, when the time gets short
void SwitchToNervous();

// Screen Music
void PlayScreenMusic();

// Stops all music
void StopSound();

// Play a step sound, when advanced ahaead
void PlayStep();

// Plays a loud step
void PlayLoudStep();

// Plays a step without pausing
void DirectStep();

// Plays a Box Move Sound
void PlayMoveBox();

// Plays a no result Sound
void PlayNoResult();

// Plays the applause sound
void PlayApplause();

// Plays a breath sound
void PlayBreath();

// Plays the sound fore the box in position
void PlayYeah();

#endif